/*
 * abissd/notify.c - abissd, "notification" message
 *
 * Written 2005 by Werner Almesberger
 *
 * (C) Copyright Koninklijke Philips Electronics NV 2005. All rights reserved.
 * For licensing and warranty information, see the file ../../COPYING.LGPLv21
 */


#include <stdio.h>

#include <abiss_msg.h>
#include <abissd.h>

#include "common.h"
#include "stream.h"


size_t abissd_notify(void *buffer)
{
    struct abissd_notification_msg *msg = buffer;
    struct stream *stream;

    if (verbose > 1) {
	fprintf(stderr,"notification id: dev 0x%llx, ino %llu, fid 0x%llx\n",
	    (unsigned long long) msg->id.dev,
	    (unsigned long long) msg->id.ino,
	    (unsigned long long) msg->id.fid);
    }

    stream = find_stream(&msg->id);
    if (!stream) {
	fprintf(stderr,"cannot notify (not in list)\n");
	return sizeof(*msg);
    }
  
    if (stream->sched_ops->notify)
	stream->sched_ops->notify(stream,buffer);

    return 0;
}
