/*
 * tests/elv/Script.c - Wrapper for test script
 *
 * Written 2004-2005 by Werner Almesberger
 *
 * (C) Copyright Koninklijke Philips Electronics NV 2004-2005. All rights
 * reserved. For licensing and warranty information, see the file
 * ../../COPYING.GPLv2
 */


#include <assert.h>

#include "Kglue.h"


#define RT	(REQ_ABISS | REQ_ABISS_PRIO(0))
#define BE1	(REQ_ABISS | REQ_ABISS_PRIO(1))
#define BE2	(REQ_ABISS | REQ_ABISS_PRIO(2))
#define BE3	(REQ_ABISS | REQ_ABISS_PRIO(3))
#define BE4	(REQ_ABISS | REQ_ABISS_PRIO(4))
#define BE5	(REQ_ABISS | REQ_ABISS_PRIO(5))
#define BE6	(REQ_ABISS | REQ_ABISS_PRIO(6))
#define BE7	(REQ_ABISS | REQ_ABISS_PRIO(7))
#define BE	BE7

#define RTw	(RT | REQ_RW)
#define BEw1	(BE1 | REQ_RW)
#define BEw2	(BE2 | REQ_RW)
#define BEw3	(BE3 | REQ_RW)
#define BEw4	(BE4 | REQ_RW)
#define BEw5	(BE5 | REQ_RW)
#define BEw6	(BE6 | REQ_RW)
#define BEw7	(BE7 | REQ_RW)
#define BEw	(BE7 | REQ_RW)

#define NO	0
#define SUSP	(REQ_SOFTBARRIER | REQ_HARDBARRIER | REQ_PM_SUSPEND | \
		REQ_NOMERGE | REQ_ABISS_HEAD)


#define enq(id,flags,start,secs) \
	struct request *id = \
	    ({ struct request *_rq = concoct_rq(flags,start,secs); \
	       if (_rq) enqueue(_rq); \
	       _rq; });

#define cmd(id,flags) \
	struct request *id = \
            ({ struct request *_rq = concoct_rq(flags | REQ_DRIVE_CMD,0,0); \
               if (_rq) enqueue(_rq); \
               _rq; });

#define deq(id,...) \
	dequeue(RQ_GET | RQ_END,id,#id,__FILE__,__LINE__ , ##__VA_ARGS__, \
	    -1,-1,-1);

#define begin(id,...) \
	dequeue(RQ_GET,id,#id,__FILE__,__LINE__ , ##__VA_ARGS__,-1,-1,-1);

#define end(id,...) \
	dequeue(RQ_END,id,#id,__FILE__,__LINE__ , ##__VA_ARGS__,-1,-1,-1);

#define upgrade(offset,prio) \
	upgrade(offset,REQ_ABISS_GET_PRIO(prio));

#define phase(rw) phase(rw);

#define push	push();


void do_script(void)
{
#include SCRIPT_FILE
}
